// error.h -- do not modify. Use error_config.h for configuration.

#ifndef ERROR_H
#define ERROR_H

#define LEDMESSAGE_REPETITIONS  3

//////////////////////////////////////////////////////////////////////////////////
// include project dependent controller pin definitions for BT05 control lines  //
// project dependent config file - use error_config.h as template               //
#include PIN_CONFIG_H           // Symbol to be defined via compiler -D option  //
//                                                                              //
//////////////////////////////////////////////////////////////////////////////////

#ifndef CAT
    #define _CAT(a, b)  a ## b
    #define CAT(a, b)   _CAT(a, b)
#endif // CAT

inline static void initErrorLED() {
    CAT(DDR, ERROR_LED_PORT) |= (1 << ERROR_LED_BIT);
}

inline static void setErrorLED(uint8_t st) {
    if (st)
        CAT(PORT, ERROR_LED_PORT) |=  (1 << ERROR_LED_BIT);
    else
        CAT(PORT, ERROR_LED_PORT) &= ~(1 << ERROR_LED_BIT);
}


void toggleErrorLED(void);
void flashErrorLED();

void ledMessage(uint8_t moduleID, uint16_t errno);       // repeat message LEDMESSAGE_REPETITIONS times and return
void error(uint8_t moduleID, uint16_t errno);            // error shutdown with endless message repetition

void delay_10ms(uint16_t ticks);

#endif // ERROR_H
